'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var core = require('@vue-storefront/core');
var Strapi = require('strapi-sdk-js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var Strapi__default = /*#__PURE__*/_interopDefaultLegacy(Strapi);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

var getContent = function (_a, _b) {
    var Strapi = _a.client;
    var contentType = _b.contentType, id = _b.id, _c = _b.find, find = _c === void 0 ? false : _c, _d = _b.findOne, findOne = _d === void 0 ? false : _d, sort = _b.sort, pagination = _b.pagination, filters = _b.filters, locale = _b.locale, _e = _b.populate // check out https://market.strapi.io/plugins/strapi-plugin-populate-deep
    , populate = _e === void 0 ? "deep" : _e // check out https://market.strapi.io/plugins/strapi-plugin-populate-deep
    ;
    return __awaiter(void 0, void 0, void 0, function () {
        var method, params, data, error_1;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    params = {
                        sort: sort,
                        pagination: pagination,
                        filters: filters,
                        locale: locale,
                        populate: populate
                    };
                    if (!contentType) {
                        core.Logger.error('contentType must be specified, eg "blog-post" or "blog-posts"');
                        return [2 /*return*/];
                    }
                    if (find && findOne) {
                        core.Logger.error('Please specify only one method `find` or `findOne`');
                        return [2 /*return*/];
                    }
                    if (!find && !findOne) {
                        core.Logger.error('Please select a search method `find` or `findOne`');
                        return [2 /*return*/];
                    }
                    if (find && id) {
                        core.Logger.warn('`id` will be ignored in this case as it can only be used when searching using `findOne`');
                    }
                    if (find && !id && !findOne) {
                        method = Strapi.find(contentType, params);
                    }
                    else if (findOne && id) {
                        method = Strapi.findOne(contentType, id, params);
                    }
                    else {
                        Strapi.find(contentType, params);
                    }
                    _f.label = 1;
                case 1:
                    _f.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, method];
                case 2:
                    data = (_f.sent()).data;
                    return [2 /*return*/, Array.isArray(data) ? data : [data]];
                case 3:
                    error_1 = _f.sent();
                    core.Logger.error('error', error_1);
                    throw error_1;
                case 4: return [2 /*return*/];
            }
        });
    });
};

var api = /*#__PURE__*/Object.freeze({
    __proto__: null,
    getContent: getContent
});

var setup = function (options) {
    var client = new Strapi__default["default"](options);
    return {
        client: client,
        config: __assign({}, options),
    };
};
var createApiClient = core.apiClientFactory({
    onCreate: setup,
    api: api,
}).createApiClient;

exports.createApiClient = createApiClient;
//# sourceMappingURL=index.js.map
